<?php

namespace Drupal\email_content_templates\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\email_content_templates\EmailContentTemplateInterface;
use Drupal\email_content_templates\EmailContentTemplatesInfoPluginManager;
use Drupal\email_content_templates\EmailContentTemplatesServiceInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\HttpFoundation\Request;

class PreviewController extends ControllerBase {

  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('plugin.manager.email_content_templates_info'),
      $container->get('email_content_templates.service')
    );
  }

  public function __construct(EmailContentTemplatesInfoPluginManager $email_info_manager, EmailContentTemplatesServiceInterface $email_content_temlates_service){
    $this->emailInfoManager = $email_info_manager;
    $this->emailContentTemplatesService = $email_content_temlates_service;
  }

  public function preview(EmailContentTemplateInterface $email_content_template, Request $request) {
    $template = $this->entityTypeManager()->getStorage('email_content_template')
      ->load($request->get('template_id'));
    $email_plugin = $this->emailInfoManager->createInstance($template->getEmailPlugin());
    $token_map = $email_plugin->paramTokenMap();
    $params = ['template' => $template];
    foreach ($token_map as $param_name => $entity_type) {
      $entity_id = $request->get($param_name);
      if (!empty($entity_id)) {
        $entity = $this->entityTypeManager()->getStorage($entity_type)
          ->load($entity_id);
        $params[$param_name] = $entity;
      }
    }

    $message = [];
    $this->emailContentTemplatesService->prepareMessage($message, $params, $template);


    return ['#markup' => $message['body'][0]];
  }

}
