<?php

namespace Drupal\email_content_templates;

use Drupal\Component\Plugin\PluginBase;

/**
 * Base class for email_content_templates_info plugins.
 */
abstract class EmailContentTemplatesInfoPluginBase extends PluginBase implements EmailContentTemplatesInfoInterface {

  /**
   * {@inheritdoc}
   */
  public function label() {
    // Cast the label to a string since it is a TranslatableMarkup object.
    return (string) $this->pluginDefinition['label'];
  }

  /**
   * {@inheritdoc}
   */
  public function paramTokenMap() {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function applies(EmailContentTemplateInterface $template, array $message): int {
    return 1;
  }

  /**
   * {@inheritdoc}
   */
  public function alterMail(EmailContentTemplateInterface $template, array &$message): void {
    // Dont alter anything.
  }

  /**
   * {@inheritdoc}
   */
  public function getTestForm(): array {
    $param_token_map = $this->paramTokenMap();
    $form = [];
    foreach ($param_token_map as $param_name => $entity_type) {
      $form[$param_name] = [
        '#title' => $param_name,
        '#type' => 'entity_autocomplete',
        '#target_type' => $entity_type,
        '#required' => TRUE,
      ];
    }
    return $form;
  }

}
