<?php

namespace Drupal\email_content_templates;

/**
 * Provides Email Preparation functionality.
 */
interface EmailContentTemplatesServiceInterface {

  /**
   * Helper function for preparing mails with template values.
   *
   * @param array $mail
   *   The message array.
   * @param array $params
   *   The message params.
   * @param \Drupal\email_content_templates\EmailContentTemplateInterface $template
   *   The template.
   * @param \Drupal\email_content_templates\EmailContentTemplatesInfoInterface|null $plugin
   *   The plugin.
   */
  public function prepareMessage(array &$mail, array $params, EmailContentTemplateInterface $template, EmailContentTemplatesInfoInterface $plugin = NULL);

}
